string Description = "Basic Alpha";

float3 DirectionToLight = float3(1.0, 1.0, -1.0);
float4x4 WorldViewProj : WorldViewProjection;

struct AppData
{
    float3 position : POSITION;
    float3 normal : NORMAL;
};

struct VertexOutput
{
    float4 hPosition : POSITION;
    float4 color : COLOR0;
};

struct PixelOutput
{
    float4 color : COLOR;
};

VertexOutput VS_TransformAndLight(AppData IN) 
{
    VertexOutput OUT;
    OUT.hPosition = mul(float4(IN.position, 1.0),
                        WorldViewProj);
    float4 diffuseColor = max(0, dot(IN.normal, normalize(DirectionToLight)))
                         * float4(0.5, 1.0, 0.5, 0.5);

    OUT.color = diffuseColor;

    return OUT;
}

PixelOutput PS_Color(VertexOutput IN)
{
    PixelOutput OUT;
    OUT.color = IN.color;
    return OUT;
}

technique simpleTechnique
{
    pass p0 
    {        
        VertexShader = compile vs_2_0 VS_TransformAndLight();
        PixelShader  = compile ps_2_0 PS_Color();

        AlphaBlendEnable = true;
        SrcBlend = SrcAlpha;
        DestBlend = InvSrcAlpha;
        BlendOp = Add;
        ZEnable = true;
        ZWriteEnable = false;
        CullMode = None;
    }
}